#ifndef _DATE_TIME_H
#define _DATE_TIME_H

//Dependencies
#include <stdint.h>

//C++ guard
#ifdef __cplusplus
extern "C" {
#endif


/**
 * @file
 * @brief Date and time representation
 * 
 * Nalezeno na webu, otestováno na příštích 20 let, ten přepočet je sice krátký, ale dost
 * neprůhledný kus kódu, kterému by snad rozuměl astronom. Nicméně to funguje a pro zpětný
 * převod programátor může použít systémové prostředky a budou fungovat stejně.
 * 
 **/

typedef struct {
  uint16_t year;
  uint8_t  month;
  uint8_t  day;
  
  uint8_t  hours;
  uint8_t  minutes;
  uint8_t  seconds;
} DateTime;

/**
 * @brief Convert Unix timestamp to date
 * @param t Unix timestamp
 * @param date Pointer to a structure representing the date and time
 **/
void     convertUnixTimeToDate (uint32_t t, DateTime * date);
/**
 * @brief Convert date to Unix timestamp
 * @param date Pointer to a structure representing the date and time
 * @return Unix timestamp
 **/
uint32_t convertDateToUnixTime (const DateTime * date);

//C++ guard
#ifdef __cplusplus
}
#endif

#endif

